/**********************************************************************
 *
 *              ***   HAPPy Pascal compiler ***
 *                    eTu[`Q
 *
 *      void skip(Set fsys)
 *      void updatelc(int upsize)
 *      void getbounds(stp *fsp,long *fmin, long *fmax)
 *      boolean equalbounds(stp *fsp1, stp *fsp2)
 *      int align(stp *fsp,int flc)
 *      void conststrings(stp **fsp, union valu *fvalu)
 *      void constant(Set fsys, stp **fsp, union valu *fvalu)
 *      boolean compatible(stp *fsp1,stp *fsp2)
 *      boolean assigncompati(stp *fsp1,stp *fsp2)
 *      boolean string(stp *fsp)
 *
 *                Copyright (c) H.Asano 1992,1994.
 *
 **********************************************************************/

#define EXTERN extern
#include <string.h>
#include "pascomp.h"

typedef enum _sign {none, pos, neg } signflag ;

boolean string(stp*) ;
extern void pcerr(int,char*) ;
extern void insymbol(void) ;
extern ctp  *searchid(Set) ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *orset(Set*,Set*)    ;
extern void term(void) ;
extern void *Malloc(int) ;
extern void applied(ctp*,int) ;

/**************************************/
/* skip() : 񕜂̂߂symbol  */
/*          L[ɂēǂݔ΂      */
/**************************************/
void skip(Set fsys)
{
     while(! inset(fsys,sy))
      insymbol() ;
}

/**************************************/
/* updatelc() : location counterXV  */
/**************************************/
void updatelc(int upsize)
{
       if(Maxaddr-upsize < lc)
        pcerr(609,"") ;                 /* ϐłȂ           */
       else lc += upsize ;              /* lc XV                  */
}

/*******************************************************/
/* getbounds() : ͈͌^,^,^W^,񋓌^  */
/*               l߂                   */
/*  (* assume fsp<>intptr and fsp<>realptr *)          */
/*******************************************************/
void getbounds(stp *fsp,long *fmin, long *fmax)
{
     if(!fsp) return ;

     if(fsp == charptr) {               /* ^                     */
      *fmin = ordminchar          ;     /*   ԏR[h     */
      *fmax = ordmaxchar          ;     /*   ԑ傫R[h     */
     }
     else if(fsp == intptr) {           /* ^                     */
      *fmin = -Maxint ;                 /*   -Maxint .. Maxint        */
      *fmax =  Maxint ;
     }
     else if(fsp->form == subrange) {   /* ͈͌^                     */
      *fmin = fsp->sf.su.min      ;     /*                        */
      *fmax = fsp->sf.su.max      ;     /*                        */
     }
     else if(fsp->form == power) {      /* W^                     */
      *fmin = fsp->sf.pw.elmin   ;      /*                        */
      *fmax = fsp->sf.pw.elmax   ;      /*                        */
     }
     else if(fsp->sf.sc.fconst) {       /* 񋓌^̎                 */
      *fmax = fsp->sf.sc.fconst->n.values.ival ; /* Ō̗񋓖̒l  */
      *fmin = 0 ;
     }
}

/****************************************/
/* equalbounds() : 2̌^̏ */
/*                 肷     */
/****************************************/
boolean equalbounds(stp *fsp1, stp *fsp2)
{
  long lmin1,lmin2,lmax1,lmax2 ;

     if((!fsp1) || (!fsp2)) return(true) ;  /* ̂ƂӖs     */

     getbounds(fsp1,&lmin1,&lmax1) ;    /* fsp1 ̉𒲂ׂ   */
     getbounds(fsp2,&lmin2,&lmax2) ;    /* fsp2 ̉𒲂ׂ   */
     return((lmin1==lmin2) && (lmax1==lmax2)) ;/* ƂƂ^*/
}

/**************************************/
/* alignquot() : ^̋E߂     */
/*     align  ֐              */
/**************************************/
static int alignquot(stp *fsp)
{
     if(!fsp) return(1) ;               /* ^|C^Ȃ1      */

     switch(fsp->form) {
      case scalar   :                   /* XJ[^    */
             if(fsp==intptr)  return(intal)  ;           /* integer^     */
             if(fsp==boolptr) return(boolal) ;           /* boolean^     */
             if(fsp==charptr) return(charal) ;           /* char   ^     */
             if(fsp==realptr) return(realal) ;           /* real   ^     */
             if(fsp->sf.sc.scalkind == declared)         /*    ^     */
                              return(intal)  ;
             return(parmal) ;                            /* parameter list*/
      case subrange :                   /* ͈͌^        */
             return(alignquot(fsp->sf.su.rangetype)) ;   /* ͈͂̌̌^  */
      case pointer  :                   /* |C^^    */
             return(adral)  ;
      case power    :                   /* W^        */
             return(setal)  ;
      case files    :                   /* t@C^    */
             return(fileal) ;
      case arrays   :                   /* z^        */
             return(alignquot(fsp->sf.ar.aeltype)) ;
                                        /* vf̌^      */
      case records  :                   /* R[h      */
             return(recal)  ;
/*    case variant  : */                /* σR[h  */
/*    case tagfld   : */                /* σR[h̃^O */
                                        /* ̃[g͂Ȃ     */
     }
}

/************************************************/
/* align() : ^ɉJnԒn߂ */
/*            flc    : ̔Ԓn                 */
/*            return : JnԒn         */
/************************************************/
int align(stp *fsp,int flc)
{
  int k, l;

     k = alignquot(fsp) ;               /* ̌^̋El߂     */
     l = flc - 1 + k    ;               /* flcȏ̍ŏǩ{ */
     return(l - l%k)    ;               /* ԋp                   */
}

/***************************************/
/* constident():  O萔̏       */
/***************************************/
static void constident(signflag fsign,stp **fsp, union valu *fvalu)
{
  stp *lsp ;
  ctp *lcp ;
  csp *lvp ;
  Set ws ;

     mkset(&ws, konst, -1)   ;
     lcp = searchid(ws)      ;          /* 萔̖OT         */
     applied(lcp,level)      ;          /* QƖ`F[             */
     lsp = lcp->idtype       ;
     *fvalu = lcp->n.values  ;          /* O̒l                   */
     if(fsign != none) {                /* 鎞               */
      if(lsp == intptr) {               /*                        */
       if(fsign == neg)
        (*fvalu).ival = -(*fvalu).ival; /*  l𔽓]                  */
      }
      else if(lsp == realptr) {         /*                        */
       if(fsign == neg) {
        lvp = (csp*)Malloc(sizeof(csp));
        lvp->cclass = real ;
        lvp->c.rval = (char*)Malloc(Maxdiglng+1+1);
        *(lvp->c.rval) = ((*(*fvalu).valp->c.rval)=='-')/*  - * - = + */
                          ? (char)' ' : (char)'-'  ;    /*  + * - = - */
        strcpy(lvp->c.rval+1,
              (*fvalu).valp->c.rval+1); /*  gڂ            */
        (*fvalu).valp = lvp ;
       }
      }
      else   pcerr(105,lcp->name) ;     /*  łȂ̂      */
                                        /*  ̂ŁA͑ʖ*/
                                        /*  ̃G[bZ[W        */
     }
     *fsp   = lsp ;
     insymbol()   ;
}

/***************************************/
/* conststrings():  萔̏   */
/***************************************/
void conststrings(stp **fsp, union valu *fvalu)
{
  stp *lsp,*lsp1 ;

     if(lgth == 1)      lsp = charptr ; /*   1͕^            */
     else if(lgth == 0) lsp = nil ;     /*   0̓G[            */
     else {
      lsp = (stp*)Malloc(sizeof(stp));
      lsp->size = lgth*charsize ;       /*                    */
      lsp->form = arrays ;              /* z^                     */
      lsp->sf.ar.packed  = true    ;    /* lߍ݌^ł           */
      lsp->sf.ar.aeltype = charptr ;    /*  vf̌^͕^          */
      lsp1 = (stp*)Malloc(sizeof(stp)) ;/*  Y̌^                */
      lsp1->form = subrange          ;  /*        ͈͌^              */
      lsp1->size = intsize           ;
      lsp1->sf.su.rangetype = intptr ;
      lsp1->sf.su.min = 1            ;  /*  Ỷl1           */
      lsp1->sf.su.max = (long)lgth   ;  /*  Y̏l͕    */
      lsp->sf.ar.inxtype = lsp1      ;  /*  Y̌^͈̔͌^Ƃ*/
     }
     *fvalu = val ;                     /*  ԋp              */
     *fsp   = lsp ;
}

/*********************************************/
/*     constant() : 萔̏               */
/*********************************************/
void constant(Set fsys, stp **fsp, union valu *fvalu)
{
  stp *lsp ;
  signflag sign ;
  Set ws ;

     lsp = nil ;
     (*fvalu).ival = 0 ;

     if(! inset(constbegsys,sy)) {    /* 萔ƂċȂ  */
      pcerr(50,"") ;                  /*  萔Ɍ肪       */
      ws = fsys                 ;
      orset(&ws,&constbegsys)   ;
      skip(ws)                  ;     /* fsys+constbegsys܂skip*/
     }

     if(inset(constbegsys,sy)) {      /* 萔ƂOK̎        */
      if(sy == stringconst) {         /*   萔̎        */
       conststrings(fsp,fvalu)  ;     /*   萔̏      */
       insymbol()               ;
      }
      else {
     /***  ȊO̎ ܂(+ -)̏ ***/

       sign = none ;
       if((op == plus) || (op == minus)) {  /* + -            */
        sign = (op == plus) ? pos : neg ;   /*  ̑I        */
        insymbol() ;
       }

       if(sy == ident)                  /* O̎                   */
        constident(sign,fsp,fvalu) ;    /* O萔̏             */

       else if(sy == intconst) {        /* 萔̎               */

        if(sign == neg) val.ival = -val.ival ; /* -̎͒l𔽓] */
        *fsp   = intptr     ;
        *fvalu = val        ;
        insymbol()          ;
       }

       else if(sy == realconst) {       /* 萔̎               */
        if(sign == neg)
        *(val.valp->c.rval) = '-' ;     /*  ɕ̕      */
        *fsp = realptr      ;
        *fvalu = val        ;
        insymbol()          ;
       }

       else {                           /* ȊO                   */
        pcerr(106,"") ;                 /* Ȃ                   */
        skip(fsys)    ;
       }
      }
     }

     if(! inset(fsys,sy)) {
      pcerr(6,"") ;                     /* sȋLꂽ */
      skip(fsys)  ;
     }
}

/********************************************/
/* compatible() : 2̌^K邩   */
/********************************************/
boolean compatible(stp *fsp1,stp *fsp2)
{

     if(fsp1 == fsp2) return(true) ;    /* ^̃AhXȂ瓙*/

     if((!fsp1) || (!fsp2)) return(true);
                                        /* ǂ炩nilȂΤł
                                          G[bZ[WoĂ
                                          ͂Ȃ̂ŁAł
                                          G[oȂtrue*/

     if(fsp1->form == fsp2->form)       /* ^                 */
      switch(fsp1->form) {
       case subrange : return           /* ͈͌^                 */
                      (fsp1->sf.su.rangetype == fsp2->sf.su.rangetype);
                                        /*    ^            */

       case power    :                  /* W^                     */
                      if((fsp1->sf.pw.packed == both) ||
                         (fsp2->sf.pw.packed == both))
                        return(compatible(fsp1->sf.pw.elset, /*̌^*/
                                          fsp2->sf.pw.elset )) ;/*DK*/
                      else return
                      (!(fsp1->sf.pw.packed ^ fsp2->sf.pw.packed) &&
                                        /* Ƃl߂Ȃl߂ */
                       compatible(fsp1->sf.pw.elset,     /* ̌^*/
                                  fsp2->sf.pw.elset )) ; /* K      */

       case pointer :  return           /* |C^^                 */
                      ((fsp1 == nilptr) || (fsp2 == nilptr)) ;
                                        /*   nil͑SĂ߲^ƓK */

       case arrays  :  return           /* z^                     */
                      (string(fsp1) && string(fsp2) &&
                        (fsp1->sf.ar.inxtype->sf.su.max ==
                         fsp2->sf.ar.inxtype->sf.su.max));
                                         /* ̐^
                                            ͓K              */

       default       : return(false)  ; /* ȊǑ^͕sK       */
      }

     else if(fsp1->form == subrange)    /* fsp1fsp2͈͂̕     */
      return (fsp1->sf.su.rangetype == fsp2) ;
     else if(fsp2->form == subrange)    /* fsp2fsp1͈͂̕     */
      return (fsp1 == fsp2->sf.su.rangetype) ;
     else return(false) ;
}

/***************************************************/
/* assigncompati() : 2̌^̑\𔻒肷 */
/*           ^fsp1ɑ΂Č^fsp2\̎^  */
/***************************************************/
boolean assigncompati(stp *fsp1,stp *fsp2)
{
     if(fsp1 == fsp2)                   /* ^                     */
      return(fsp1->assignflag) ;        /* \̃`FbN       */
     else if((fsp1 == realptr) && compatible(fsp2,intptr)) return(true) ;
     else return(compatible(fsp1,fsp2)) ;
}

/**************************************/
/* string() : ^񂩔肷    */
/**************************************/
boolean string(stp *fsp)
{
     if(!fsp) return(false) ;

     return
        ((fsp->form == arrays)                       /* z^         */
     && (fsp->sf.ar.packed)                         /* packedw肠 */
     && (compatible(fsp->sf.ar.aeltype,charptr))    /* vf̌^^*/
     && (fsp->sf.ar.inxtype->form == subrange)      /* Y̌^͔͈ */
     && (fsp->sf.ar.inxtype->sf.su.min == 1)        /* l1      */
     && (fsp->sf.ar.inxtype->sf.su.max >  1 )) ;    /* l2ȏ  */
                                        /* ̎ ƔF߂  */
                                        /* LȊO͕ł͂Ȃ   */
}
